/**
 * Copyright 2013-2020 the original author or authors from the JHipster project.
 *
 * This file is part of the JHipster project, see http://www.jhipster.tech/
 * for more information.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

const Options = {
  SKIP_CLIENT: 'skipClient',
  SKIP_SERVER: 'skipServer',
  NO_FLUENT_METHOD: 'noFluentMethod',
  READ_ONLY: 'readOnly',
  FILTER: 'filter',
  EMBEDDED: 'embedded'
};

const optionNames = Object.values(Options);

Options.forEach = passedFunction => {
  if (!passedFunction) {
    throw new Error('A function has to be passed to loop over the unary options.');
  }
  optionNames.forEach(optionName => {
    passedFunction(optionName);
  });
};

Options.exists = option => Object.values(Options).includes(option);

module.exports = Options;
